var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { AsyncAction } from "./AsyncAction";
import { BaseTypedAction } from "./BaseTypedAction";
import { wrapError } from "../utils";
export const getParallelTasksAsyncActionClass = () => class PTSuperClass extends AsyncAction {
    execute(dispatch, getState) {
        return __awaiter(this, void 0, void 0, function* () {
            const results = yield Promise.all(this.payload.tasks.map((task) => {
                let taskResult = null;
                if (typeof task === 'function') {
                    try {
                        taskResult = task(getState);
                    }
                    catch (error) {
                        return wrapError(error);
                    }
                }
                const typedAction = taskResult === null ? task : taskResult;
                return Promise.resolve(typedAction instanceof BaseTypedAction ?
                    dispatch(typedAction) :
                    typedAction).catch((error) => wrapError(error));
            }));
            if (typeof this.payload.onComplete === 'function') {
                const onResolveResult = this.payload.onComplete(results, dispatch, getState);
                if (typeof onResolveResult !== 'undefined') {
                    return onResolveResult;
                }
            }
            return results;
        });
    }
};
