import { isTypedAction } from "./utils";
import { AsyncAction } from "./actions/AsyncAction";
export const typedActionMiddleware = () => (next) => (action) => {
    if (isTypedAction(action)) {
        return next(action.toPlainObject());
    }
    return next(action);
};
export const asyncTypedActionMiddleware = ({ dispatch, getState }) => (next) => (action) => {
    if (isTypedAction(action)) {
        const typedAction = action.typedAction;
        if (typedAction instanceof AsyncAction) {
            return typedAction.execute(dispatch, getState);
        }
    }
    return next(action);
};
export const typedActionMiddlewares = [
    typedActionMiddleware,
    asyncTypedActionMiddleware
];
